import{S as ea,i as ta,s as ia,e as a,k as r,w as v,t as p,M as aa,c as s,d as i,m as l,a as n,x as P,h as c,b as o,G as t,g as f,y as b,q as w,o as y,B as I,v as sa,L as na}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as ui}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Zi}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ge}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as oa}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ra(ze){let m,C,_,g,k;return g=new Zi({props:{code:`import PIL
import requests
import torch
from io import BytesIO

from diffusers import StableDiffusionInstructPix2PixPipeline


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png"

image = download_image(img_url).resize((512, 512))

pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(
    "timbrooks/instruct-pix2pix", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

prompt = "make the mountains snowy"
image = pipe(prompt=prompt, image=image).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> PIL
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInstructPix2PixPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
<span class="hljs-meta">... </span>    response = requests.get(url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>img_url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = download_image(img_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;timbrooks/instruct-pix2pix&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;make the mountains snowy&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt=prompt, image=image).images[<span class="hljs-number">0</span>]`}}),{c(){m=a("p"),C=p("Examples:"),_=r(),v(g.$$.fragment)},l(u){m=s(u,"P",{});var D=n(m);C=c(D,"Examples:"),D.forEach(i),_=l(u),P(g.$$.fragment,u)},m(u,D){f(u,m,D),t(m,C),f(u,_,D),b(g,u,D),k=!0},p:na,i(u){k||(w(g.$$.fragment,u),k=!0)},o(u){y(g.$$.fragment,u),k=!1},d(u){u&&i(m),u&&i(_),I(g,u)}}}function la(ze){let m,C,_,g,k,u,D,we,dt,He,E,O,ye,H,ft,Ie,ut,Re,R,W,mt,gt,We,pe,ht,Ve,ce,ke,_t,Ke,de,xt,Je,x,fe,V,vt,Pt,bt,ue,K,wt,yt,It,me,J,kt,Dt,$t,ge,Y,St,Et,Ye,T,N,De,Q,Tt,$e,jt,Qe,M,Se,j,Ee,Lt,qt,Te,At,Ct,he,Ot,Nt,je,L,Le,X,Mt,Bt,qe,Ae,Ft,Ut,_e,Z,Gt,Xe,q,B,Ce,ee,zt,Oe,Ht,Ze,te,et,A,F,Ne,ie,Rt,Me,Wt,tt,h,ae,Vt,Be,Kt,Jt,se,Yt,xe,Qt,Xt,Zt,$,ne,ei,Fe,ti,ii,U,ai,G,oe,si,re,ni,Ue,oi,ri,it;return u=new Ge({}),H=new Ge({}),Q=new Ge({}),ee=new Ge({}),te=new Zi({props:{code:`import PIL
import requests
import torch
from diffusers import StableDiffusionInstructPix2PixPipeline

model_id = "timbrooks/instruct-pix2pix"
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

url = "https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png"


def download_image(url):
    image = PIL.Image.open(requests.get(url, stream=True).raw)
    image = PIL.ImageOps.exif_transpose(image)
    image = image.convert("RGB")
    return image


image = download_image(url)

prompt = "make the mountains snowy"
edit = pipe(prompt, image=image, num_inference_steps=20, image_guidance_scale=1.5, guidance_scale=7).images[0]
images[0].save("snowy_mountains.png")`,highlighted:`<span class="hljs-keyword">import</span> PIL
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionInstructPix2PixPipeline

model_id = <span class="hljs-string">&quot;timbrooks/instruct-pix2pix&quot;</span>
pipe = StableDiffusionInstructPix2PixPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/diffusers-images-docs/resolve/main/mountain.png&quot;</span>


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
    image = PIL.Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
    image = PIL.ImageOps.exif_transpose(image)
    image = image.convert(<span class="hljs-string">&quot;RGB&quot;</span>)
    <span class="hljs-keyword">return</span> image


image = download_image(url)

prompt = <span class="hljs-string">&quot;make the mountains snowy&quot;</span>
edit = pipe(prompt, image=image, num_inference_steps=<span class="hljs-number">20</span>, image_guidance_scale=<span class="hljs-number">1.5</span>, guidance_scale=<span class="hljs-number">7</span>).images[<span class="hljs-number">0</span>]
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;snowy_mountains.png&quot;</span>)`}}),ie=new Ge({}),ae=new ui({props:{name:"class diffusers.StableDiffusionInstructPix2PixPipeline",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L56"}}),ne=new ui({props:{name:"__call__",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"num_inference_steps",val:": int = 100"},{name:"guidance_scale",val:": float = 7.5"},{name:"image_guidance_scale",val:": float = 1.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"}],parametersDescription:[{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch which will be repainted according to <code>prompt</code>.`,name:"image"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality. This pipeline requires a value of at least <code>1</code>.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.image_guidance_scale",description:`<strong>image_guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 1.5) &#x2014;
Image guidance scale is to push the generated image towards the inital image <code>image</code>. Image guidance
scale is enabled by setting <code>image_guidance_scale &gt; 1</code>. Higher image guidance scale encourages to
generate images that are closely linked to the source image <code>image</code>, usually at the expense of lower
image quality. This pipeline requires a value of at least <code>1</code>.`,name:"image_guidance_scale"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L126",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),U=new oa({props:{anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.__call__.example",$$slots:{default:[ra]},$$scope:{ctx:ze}}}),oe=new ui({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionInstructPix2PixPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py#L382"}}),{c(){m=a("meta"),C=r(),_=a("h1"),g=a("a"),k=a("span"),v(u.$$.fragment),D=r(),we=a("span"),dt=p("InstructPix2Pix: Learning to Follow Image Editing Instructions"),He=r(),E=a("h2"),O=a("a"),ye=a("span"),v(H.$$.fragment),ft=r(),Ie=a("span"),ut=p("Overview"),Re=r(),R=a("p"),W=a("a"),mt=p("InstructPix2Pix: Learning to Follow Image Editing Instructions"),gt=p(" by Tim Brooks, Aleksander Holynski and Alexei A. Efros."),We=r(),pe=a("p"),ht=p("The abstract of the paper is the following:"),Ve=r(),ce=a("p"),ke=a("em"),_t=p("We propose a method for editing images from human instructions: given an input image and a written instruction that tells the model what to do, our model follows these instructions to edit the image. To obtain training data for this problem, we combine the knowledge of two large pretrained models \u2014 a language model (GPT-3) and a text-to-image model (Stable Diffusion) \u2014 to generate a large dataset of image editing examples. Our conditional diffusion model, InstructPix2Pix, is trained on our generated data, and generalizes to real images and user-written instructions at inference time. Since it performs edits in the forward pass and does not require per example fine-tuning or inversion, our model edits images quickly, in a matter of seconds. We show compelling editing results for a diverse collection of input images and written instructions."),Ke=r(),de=a("p"),xt=p("Resources:"),Je=r(),x=a("ul"),fe=a("li"),V=a("a"),vt=p("Project Page"),Pt=p("."),bt=r(),ue=a("li"),K=a("a"),wt=p("Paper"),yt=p("."),It=r(),me=a("li"),J=a("a"),kt=p("Original Code"),Dt=p("."),$t=r(),ge=a("li"),Y=a("a"),St=p("Demo"),Et=p("."),Ye=r(),T=a("h2"),N=a("a"),De=a("span"),v(Q.$$.fragment),Tt=r(),$e=a("span"),jt=p("Available Pipelines:"),Qe=r(),M=a("table"),Se=a("thead"),j=a("tr"),Ee=a("th"),Lt=p("Pipeline"),qt=r(),Te=a("th"),At=p("Tasks"),Ct=r(),he=a("th"),Ot=p("Demo"),Nt=r(),je=a("tbody"),L=a("tr"),Le=a("td"),X=a("a"),Mt=p("StableDiffusionInstructPix2PixPipeline"),Bt=r(),qe=a("td"),Ae=a("em"),Ft=p("Text-Based Image Editing"),Ut=r(),_e=a("td"),Z=a("a"),Gt=p("\u{1F917} Space"),Xe=r(),q=a("h2"),B=a("a"),Ce=a("span"),v(ee.$$.fragment),zt=r(),Oe=a("span"),Ht=p("Usage example"),Ze=r(),v(te.$$.fragment),et=r(),A=a("h2"),F=a("a"),Ne=a("span"),v(ie.$$.fragment),Rt=r(),Me=a("span"),Wt=p("StableDiffusionInstructPix2PixPipeline"),tt=r(),h=a("div"),v(ae.$$.fragment),Vt=r(),Be=a("p"),Kt=p("Pipeline for pixel-level image editing by following text instructions. Based on Stable Diffusion."),Jt=r(),se=a("p"),Yt=p("This model inherits from "),xe=a("a"),Qt=p("DiffusionPipeline"),Xt=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Zt=r(),$=a("div"),v(ne.$$.fragment),ei=r(),Fe=a("p"),ti=p("Function invoked when calling the pipeline for generation."),ii=r(),v(U.$$.fragment),ai=r(),G=a("div"),v(oe.$$.fragment),si=r(),re=a("p"),ni=p(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Ue=a("code"),oi=p("torch.device('meta') and loaded to GPU only when their specific submodule has its "),ri=p("forward` method called."),this.h()},l(e){const d=aa('[data-svelte="svelte-1phssyn"]',document.head);m=s(d,"META",{name:!0,content:!0}),d.forEach(i),C=l(e),_=s(e,"H1",{class:!0});var le=n(_);g=s(le,"A",{id:!0,class:!0,href:!0});var mi=n(g);k=s(mi,"SPAN",{});var gi=n(k);P(u.$$.fragment,gi),gi.forEach(i),mi.forEach(i),D=l(le),we=s(le,"SPAN",{});var hi=n(we);dt=c(hi,"InstructPix2Pix: Learning to Follow Image Editing Instructions"),hi.forEach(i),le.forEach(i),He=l(e),E=s(e,"H2",{class:!0});var at=n(E);O=s(at,"A",{id:!0,class:!0,href:!0});var _i=n(O);ye=s(_i,"SPAN",{});var xi=n(ye);P(H.$$.fragment,xi),xi.forEach(i),_i.forEach(i),ft=l(at),Ie=s(at,"SPAN",{});var vi=n(Ie);ut=c(vi,"Overview"),vi.forEach(i),at.forEach(i),Re=l(e),R=s(e,"P",{});var li=n(R);W=s(li,"A",{href:!0,rel:!0});var Pi=n(W);mt=c(Pi,"InstructPix2Pix: Learning to Follow Image Editing Instructions"),Pi.forEach(i),gt=c(li," by Tim Brooks, Aleksander Holynski and Alexei A. Efros."),li.forEach(i),We=l(e),pe=s(e,"P",{});var bi=n(pe);ht=c(bi,"The abstract of the paper is the following:"),bi.forEach(i),Ve=l(e),ce=s(e,"P",{});var wi=n(ce);ke=s(wi,"EM",{});var yi=n(ke);_t=c(yi,"We propose a method for editing images from human instructions: given an input image and a written instruction that tells the model what to do, our model follows these instructions to edit the image. To obtain training data for this problem, we combine the knowledge of two large pretrained models \u2014 a language model (GPT-3) and a text-to-image model (Stable Diffusion) \u2014 to generate a large dataset of image editing examples. Our conditional diffusion model, InstructPix2Pix, is trained on our generated data, and generalizes to real images and user-written instructions at inference time. Since it performs edits in the forward pass and does not require per example fine-tuning or inversion, our model edits images quickly, in a matter of seconds. We show compelling editing results for a diverse collection of input images and written instructions."),yi.forEach(i),wi.forEach(i),Ke=l(e),de=s(e,"P",{});var Ii=n(de);xt=c(Ii,"Resources:"),Ii.forEach(i),Je=l(e),x=s(e,"UL",{});var z=n(x);fe=s(z,"LI",{});var pi=n(fe);V=s(pi,"A",{href:!0,rel:!0});var ki=n(V);vt=c(ki,"Project Page"),ki.forEach(i),Pt=c(pi,"."),pi.forEach(i),bt=l(z),ue=s(z,"LI",{});var ci=n(ue);K=s(ci,"A",{href:!0,rel:!0});var Di=n(K);wt=c(Di,"Paper"),Di.forEach(i),yt=c(ci,"."),ci.forEach(i),It=l(z),me=s(z,"LI",{});var di=n(me);J=s(di,"A",{href:!0,rel:!0});var $i=n(J);kt=c($i,"Original Code"),$i.forEach(i),Dt=c(di,"."),di.forEach(i),$t=l(z),ge=s(z,"LI",{});var fi=n(ge);Y=s(fi,"A",{href:!0,rel:!0});var Si=n(Y);St=c(Si,"Demo"),Si.forEach(i),Et=c(fi,"."),fi.forEach(i),z.forEach(i),Ye=l(e),T=s(e,"H2",{class:!0});var st=n(T);N=s(st,"A",{id:!0,class:!0,href:!0});var Ei=n(N);De=s(Ei,"SPAN",{});var Ti=n(De);P(Q.$$.fragment,Ti),Ti.forEach(i),Ei.forEach(i),Tt=l(st),$e=s(st,"SPAN",{});var ji=n($e);jt=c(ji,"Available Pipelines:"),ji.forEach(i),st.forEach(i),Qe=l(e),M=s(e,"TABLE",{});var nt=n(M);Se=s(nt,"THEAD",{});var Li=n(Se);j=s(Li,"TR",{});var ve=n(j);Ee=s(ve,"TH",{});var qi=n(Ee);Lt=c(qi,"Pipeline"),qi.forEach(i),qt=l(ve),Te=s(ve,"TH",{});var Ai=n(Te);At=c(Ai,"Tasks"),Ai.forEach(i),Ct=l(ve),he=s(ve,"TH",{align:!0});var Ci=n(he);Ot=c(Ci,"Demo"),Ci.forEach(i),ve.forEach(i),Li.forEach(i),Nt=l(nt),je=s(nt,"TBODY",{});var Oi=n(je);L=s(Oi,"TR",{});var Pe=n(L);Le=s(Pe,"TD",{});var Ni=n(Le);X=s(Ni,"A",{href:!0,rel:!0});var Mi=n(X);Mt=c(Mi,"StableDiffusionInstructPix2PixPipeline"),Mi.forEach(i),Ni.forEach(i),Bt=l(Pe),qe=s(Pe,"TD",{});var Bi=n(qe);Ae=s(Bi,"EM",{});var Fi=n(Ae);Ft=c(Fi,"Text-Based Image Editing"),Fi.forEach(i),Bi.forEach(i),Ut=l(Pe),_e=s(Pe,"TD",{align:!0});var Ui=n(_e);Z=s(Ui,"A",{href:!0,rel:!0});var Gi=n(Z);Gt=c(Gi,"\u{1F917} Space"),Gi.forEach(i),Ui.forEach(i),Pe.forEach(i),Oi.forEach(i),nt.forEach(i),Xe=l(e),q=s(e,"H2",{class:!0});var ot=n(q);B=s(ot,"A",{id:!0,class:!0,href:!0});var zi=n(B);Ce=s(zi,"SPAN",{});var Hi=n(Ce);P(ee.$$.fragment,Hi),Hi.forEach(i),zi.forEach(i),zt=l(ot),Oe=s(ot,"SPAN",{});var Ri=n(Oe);Ht=c(Ri,"Usage example"),Ri.forEach(i),ot.forEach(i),Ze=l(e),P(te.$$.fragment,e),et=l(e),A=s(e,"H2",{class:!0});var rt=n(A);F=s(rt,"A",{id:!0,class:!0,href:!0});var Wi=n(F);Ne=s(Wi,"SPAN",{});var Vi=n(Ne);P(ie.$$.fragment,Vi),Vi.forEach(i),Wi.forEach(i),Rt=l(rt),Me=s(rt,"SPAN",{});var Ki=n(Me);Wt=c(Ki,"StableDiffusionInstructPix2PixPipeline"),Ki.forEach(i),rt.forEach(i),tt=l(e),h=s(e,"DIV",{class:!0});var S=n(h);P(ae.$$.fragment,S),Vt=l(S),Be=s(S,"P",{});var Ji=n(Be);Kt=c(Ji,"Pipeline for pixel-level image editing by following text instructions. Based on Stable Diffusion."),Ji.forEach(i),Jt=l(S),se=s(S,"P",{});var lt=n(se);Yt=c(lt,"This model inherits from "),xe=s(lt,"A",{href:!0});var Yi=n(xe);Qt=c(Yi,"DiffusionPipeline"),Yi.forEach(i),Xt=c(lt,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),lt.forEach(i),Zt=l(S),$=s(S,"DIV",{class:!0});var be=n($);P(ne.$$.fragment,be),ei=l(be),Fe=s(be,"P",{});var Qi=n(Fe);ti=c(Qi,"Function invoked when calling the pipeline for generation."),Qi.forEach(i),ii=l(be),P(U.$$.fragment,be),be.forEach(i),ai=l(S),G=s(S,"DIV",{class:!0});var pt=n(G);P(oe.$$.fragment,pt),si=l(pt),re=s(pt,"P",{});var ct=n(re);ni=c(ct,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Ue=s(ct,"CODE",{});var Xi=n(Ue);oi=c(Xi,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Xi.forEach(i),ri=c(ct,"forward` method called."),ct.forEach(i),pt.forEach(i),S.forEach(i),this.h()},h(){o(m,"name","hf:doc:metadata"),o(m,"content",JSON.stringify(pa)),o(g,"id","instructpix2pix-learning-to-follow-image-editing-instructions"),o(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(g,"href","#instructpix2pix-learning-to-follow-image-editing-instructions"),o(_,"class","relative group"),o(O,"id","overview"),o(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(O,"href","#overview"),o(E,"class","relative group"),o(W,"href","https://arxiv.org/abs/2211.09800"),o(W,"rel","nofollow"),o(V,"href","https://www.timothybrooks.com/instruct-pix2pix"),o(V,"rel","nofollow"),o(K,"href","https://arxiv.org/abs/2211.09800"),o(K,"rel","nofollow"),o(J,"href","https://github.com/timothybrooks/instruct-pix2pix"),o(J,"rel","nofollow"),o(Y,"href","https://huggingface.co/spaces/timbrooks/instruct-pix2pix"),o(Y,"rel","nofollow"),o(N,"id","available-pipelines"),o(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(N,"href","#available-pipelines"),o(T,"class","relative group"),o(he,"align","center"),o(X,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_instruct_pix2pix.py"),o(X,"rel","nofollow"),o(Z,"href","https://huggingface.co/spaces/timbrooks/instruct-pix2pix"),o(Z,"rel","nofollow"),o(_e,"align","center"),o(B,"id","usage-example"),o(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(B,"href","#usage-example"),o(q,"class","relative group"),o(F,"id","diffusers.StableDiffusionInstructPix2PixPipeline"),o(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(F,"href","#diffusers.StableDiffusionInstructPix2PixPipeline"),o(A,"class","relative group"),o(xe,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),o($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),o(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,d){t(document.head,m),f(e,C,d),f(e,_,d),t(_,g),t(g,k),b(u,k,null),t(_,D),t(_,we),t(we,dt),f(e,He,d),f(e,E,d),t(E,O),t(O,ye),b(H,ye,null),t(E,ft),t(E,Ie),t(Ie,ut),f(e,Re,d),f(e,R,d),t(R,W),t(W,mt),t(R,gt),f(e,We,d),f(e,pe,d),t(pe,ht),f(e,Ve,d),f(e,ce,d),t(ce,ke),t(ke,_t),f(e,Ke,d),f(e,de,d),t(de,xt),f(e,Je,d),f(e,x,d),t(x,fe),t(fe,V),t(V,vt),t(fe,Pt),t(x,bt),t(x,ue),t(ue,K),t(K,wt),t(ue,yt),t(x,It),t(x,me),t(me,J),t(J,kt),t(me,Dt),t(x,$t),t(x,ge),t(ge,Y),t(Y,St),t(ge,Et),f(e,Ye,d),f(e,T,d),t(T,N),t(N,De),b(Q,De,null),t(T,Tt),t(T,$e),t($e,jt),f(e,Qe,d),f(e,M,d),t(M,Se),t(Se,j),t(j,Ee),t(Ee,Lt),t(j,qt),t(j,Te),t(Te,At),t(j,Ct),t(j,he),t(he,Ot),t(M,Nt),t(M,je),t(je,L),t(L,Le),t(Le,X),t(X,Mt),t(L,Bt),t(L,qe),t(qe,Ae),t(Ae,Ft),t(L,Ut),t(L,_e),t(_e,Z),t(Z,Gt),f(e,Xe,d),f(e,q,d),t(q,B),t(B,Ce),b(ee,Ce,null),t(q,zt),t(q,Oe),t(Oe,Ht),f(e,Ze,d),b(te,e,d),f(e,et,d),f(e,A,d),t(A,F),t(F,Ne),b(ie,Ne,null),t(A,Rt),t(A,Me),t(Me,Wt),f(e,tt,d),f(e,h,d),b(ae,h,null),t(h,Vt),t(h,Be),t(Be,Kt),t(h,Jt),t(h,se),t(se,Yt),t(se,xe),t(xe,Qt),t(se,Xt),t(h,Zt),t(h,$),b(ne,$,null),t($,ei),t($,Fe),t(Fe,ti),t($,ii),b(U,$,null),t(h,ai),t(h,G),b(oe,G,null),t(G,si),t(G,re),t(re,ni),t(re,Ue),t(Ue,oi),t(re,ri),it=!0},p(e,[d]){const le={};d&2&&(le.$$scope={dirty:d,ctx:e}),U.$set(le)},i(e){it||(w(u.$$.fragment,e),w(H.$$.fragment,e),w(Q.$$.fragment,e),w(ee.$$.fragment,e),w(te.$$.fragment,e),w(ie.$$.fragment,e),w(ae.$$.fragment,e),w(ne.$$.fragment,e),w(U.$$.fragment,e),w(oe.$$.fragment,e),it=!0)},o(e){y(u.$$.fragment,e),y(H.$$.fragment,e),y(Q.$$.fragment,e),y(ee.$$.fragment,e),y(te.$$.fragment,e),y(ie.$$.fragment,e),y(ae.$$.fragment,e),y(ne.$$.fragment,e),y(U.$$.fragment,e),y(oe.$$.fragment,e),it=!1},d(e){i(m),e&&i(C),e&&i(_),I(u),e&&i(He),e&&i(E),I(H),e&&i(Re),e&&i(R),e&&i(We),e&&i(pe),e&&i(Ve),e&&i(ce),e&&i(Ke),e&&i(de),e&&i(Je),e&&i(x),e&&i(Ye),e&&i(T),I(Q),e&&i(Qe),e&&i(M),e&&i(Xe),e&&i(q),I(ee),e&&i(Ze),I(te,e),e&&i(et),e&&i(A),I(ie),e&&i(tt),e&&i(h),I(ae),I(ne),I(U),I(oe)}}}const pa={local:"instructpix2pix-learning-to-follow-image-editing-instructions",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"diffusers.StableDiffusionInstructPix2PixPipeline",title:"StableDiffusionInstructPix2PixPipeline"}],title:"InstructPix2Pix: Learning to Follow Image Editing Instructions"};function ca(ze){return sa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ha extends ea{constructor(m){super();ta(this,m,ca,la,ia,{})}}export{ha as default,pa as metadata};
